Getting Started with Gauge Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Gauge module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.gauge.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-gauge id="gauge"></smart-gauge>

    Host container (id matches appendTo on Smart.Gauge):

    <div id="gaugeContainer"></div>

  5. Initialize after the module loads: define a const gaugeOptions object, then either bind with Smart('#gauge', ...) on the semantic tag or use new Smart.Gauge({ ...gaugeOptions, appendTo: '#gaugeContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.gauge.js';
    
    	const gaugeOptions = {};
    
    	// Option A - semantic <smart-gauge> with id="gauge"
    	Smart('#gauge', class {
    		get properties() {
    			return gaugeOptions;
    		}
    	});
    
    	// Option B - host div id="gaugeContainer"
    	// const gaugeInstance = new Smart.Gauge({
    	// 	...gaugeOptions,
    	// 	appendTo: '#gaugeContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myGauge = new Smart.Gauge('#gauge', gaugeOptions);
    	// document.body.appendChild(myGauge);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Gauge('#gauge', gaugeOptions) with appendChild, and document.createElement('smart-gauge') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Gauge({ ...options, appendTo: '#...' }); new Smart.Gauge('#gauge', gaugeOptions) plus appendChild on the returned element; and document.createElement('smart-gauge') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myGauge = new Smart.Gauge('#gauge', gaugeOptions)):

	const gaugeOptions = {};
	const myGauge = new Smart.Gauge('#gauge', gaugeOptions);
	document.body.appendChild(myGauge);
	

Create with document.createElement('smart-gauge'), assign properties (same as any custom element), then append:

	const gaugeOptions = {};
	const gauge = document.createElement('smart-gauge');
	Object.assign(gauge, gaugeOptions);
	document.body.appendChild(gauge);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.gauge.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const gaugeOptions = {};
		const gauge = new Smart.Gauge({
			...gaugeOptions,
			appendTo: '#gaugeContainer'
		});
	}
	

Demo

Note how Smart.element.js and webcomponents.min.js are declared before everything else. This is mandatory for all custom elements.

Also note that the reference to smart.tank.js is declared before Smart.gauge.js. This is important because Smart.Gauge extends Smart.Tank and reuses most of its methods.


In order to change the value of the gauge the value property has to be applied via javascript:

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.gauge.js"></script>
 <script>
     window.onload = function () {
         const gauge = document.querySelector('smart-gauge');
         gauge.value = 25;
     }
 </script>
</head>
<body>
 <smart-gauge></smart-gauge>
</body>
</html>

Demo

or set it as HTML attribute:

<smart-gauge value="25"></smart-gauge>

Demo

Appearance


Smart.Gauge uses a scale to indicate the value. The scale can be positioned inside or outside of the element thanks to the scalePosition property. The property also allows gauge without scale, when is set to "none". By default it's located inside.

Let's change the position of the scale via javascript:

<smart-gauge scale-position="outside"></smart-gauge>

Demo

The ticks of the scale can also be customized. They can be positioned above the track or inside it by setting the tickPosition property. tickPosition: track affects when analogDisplayType is fill or line.

<smart-gauge analog-display-type="fill" ticks-position="track"></smart-gauge>

Demo

The scale of the Gauge contains major and minor ticks which are visible by default. This can be re-configured. The user can display only the major, the minor or none of them if he prefers by setting the ticksVisibility property. This can also be done in the HTML code on initialization like so:

<smart-gauge ticks-visibility="major"></smart-gauge>

Demo

The scale of the Gauge has ticks and labels. Labels are also customizable. The user can control which of them to be visible:

  • none - no labels are visible
  • all - all labels are visible
  • endPoints - only the first and last labels are visible

The text of the label can also be modified thanks to the labelFormatFunction property. It's a format function that takes one argument - the value of the label. The function must return a string representing the new text for the labels. The property can be applied via javascript like so:

                    <!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.gauge.js"></script>
 <script>
     window.onload = function () {
             const gauge = document.querySelector('smart-gauge');
             gauge.labelFormatFunction = function (value) {
             return value + ' ' + 'in';
         }
     }
 </script>
</head>
<body>
 <smart-gauge></smart-gauge>
</body>
</html>

Demo

Behavior

Smart.Gauge allows two types of scales:

  • integer - the values are integers only
  • floatingPoint - the values are floating point numbers

The type of the scale is determined by the scaleType property which can be set on initialization:

<smart-gauge scale-type="integer"></smart-gauge>

Demo

or changed later when the element is ready using javascript:

<script>
     window.onload = function () {
         var gauge = document.querySelector('smart-gauge');
         gauge.scaleType = 'floatingPoint';
     }
 </script>

Demo

When the scaleType is set to "floatingPoing", the user can adjust the precision of the value via the "precisionDigits" property. This property determines how many numbers will appear after the decimal point of the current value. Can be set like every other property:

<smart-gauge precision-digits="2"></smart-gauge>

Demo

Smart.Gauge allows controlling the number significant digits shown on the scale. The significantDigits property determines how the value will be represented. For example, let's say the user wants to configure the value to contain only 3 significant digits:

<smart-gauge max="100000" significant-digits="3"></smart-gauge>

Demo

Note: significantDigits and precisionDigits can't be applied at the same time.


Smart.Gauge supports big numbers as well. The wordLength property determines the range of numbers the element can display. This property is applicable only when scaleType is 'integer'

The available word lengths are:

  • int8 : from –128 to 127
  • uint8 : from 0 to 255
  • int16 : from –32,768 to 32,767
  • uint16 : from 0 to 65,535
  • int32 : from –2,147,483,648 to 2,147,483,647. Default value.
  • uint32 : from 0 to 4,294,967,295
  • int64 : from –9,223,372,036,854,775,808 to 9,223,372,036,854,775,807
  • uint64 : from 0 to 18,446,744,073,709,551,615

Here's how to set it as attribute:

<smart-gauge scale-type="integer" word-length="uint8"></smart-gauge>

Demo


The mechanicalAction property of the element determines when the value will change. This property determines the behavior of the element. Possible values are:

  • switchUntilReleased - changes the value while the user is dragging the thumb. When the thumb is released the value is returned to it's initial position.
  • switchWhenReleased - changes the value only when the thumb is released. Otherwise the value remains unchanged.
  • switchWhileDragging - changes the value while the user is dragging the thumb and retains the last value when the thumb is released. The default value of the property.
<smart-gauge mechanical-action="switchWhenReleased"></smart-gauge>

Demo


Coerce property determines the value iteration. Once enabled the element uses the interval property to determines the next possible selectable value from the scale.

By setting the interval property the user can control the interval between the values. Interval is a property of type number and can be set on initialization or using javascript:

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.gauge.js"></script>

 <script>
     window.onload = function () {
         const gauge = document.querySelector('smart-gauge');
         gauge.interval = 10;
         gauge.coerce = true;
     }
 </script>
</head>
<body>
 <smart-gauge></smart-gauge>
</body>
</html>

If coerce is enabled the thumb will snap to the next value based on the interval.

Demo

Keyboard Support

Smart.Gauge implements the following keys:

Key Action
Arrow Up / Arrow Right Increases the value.
Arrow Left / Arrow Down Decreases the value.
Home Sets the value to min.
End Sets the value to max.

Append to the DOM:

const container = document.getElementById('gauge-container');
container.appendChild(gauge);
	

Remove from the DOM:

gauge.remove();
	

Set a property:

gauge.disabled = true;
gauge.theme = 'dark';
	

Get a property value:

const isDisabled = gauge.disabled;
const currentTheme = gauge.theme;
	

Invoke a method:

gauge.refresh();
gauge.focus();
	

Add event listener:

gauge.addEventListener('change', (event) => {
    console.log('change triggered:', event.detail.oldValue);
});
	

Remove event listener:

const handleGaugeEvent = (event) => {
    console.log('change triggered:', event.detail.oldValue);
};

gauge.addEventListener('change', handleGaugeEvent);
gauge.removeEventListener('change', handleGaugeEvent);
	

Accessibility

The Gauge component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Gauge - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/gauge/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import GaugeModule from smart-webcomponents-angular/gauge: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { GaugeModule } from 'smart-webcomponents-angular/gauge';

4 Root component (standalone)

Add GaugeModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { GaugeComponent } from 'smart-webcomponents-angular/gauge';

import { GaugeModule } from 'smart-webcomponents-angular/gauge';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ GaugeModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('gauge', { read: GaugeComponent, static: false }) gauge!: GaugeComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-gauge as needed:

 <smart-gauge #gauge id="gauge" [analogDisplayType]="'needle'" [digitalDisplay]="true"
             [startAngle]="-30" [endAngle]="210" [min]="0" [max]="100" [value]="0"></smart-gauge>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put GaugeModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put GaugeModule from smart-webcomponents-angular/gauge on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { GaugeModule } from 'smart-webcomponents-angular/gauge';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, GaugeModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The Gauge component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Gauge Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/gauge/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { Gauge } from 'smart-webcomponents-react/gauge';

const App = () => {
    // You can use useEffect here if you need lifecycle logic.
    // React.useEffect(() => {
    //     // componentDidMount logic here
    // }, []);
    
    return (
        <div>
            <Gauge 
                id="gauge" 
                analogDisplayType="needle" 
                digitalDisplay
                startAngle={-30} 
                endAngle={210} 
                min="0" 
                max="100" 
                value="0"
            />
        </div>
    );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Gauge, GaugeProps } from 'smart-webcomponents-react/gauge';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Gauge component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.